

; ========================
;
;                Multiple Document Interface
;     
; ========================


  ; .586                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\macros\macros.asm
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc
    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\oleaut32.lib
    includelib \masm32\lib\msvcrt.lib

    ; ======= Prototypes =======

    DefChildWindowProc     PROTO :DWORD, :DWORD, :DWORD, :DWORD
    WinMain                PROTO :DWORD, :DWORD, :DWORD, :DWORD
    FrameWindowProc        PROTO :DWORD, :DWORD, :DWORD, :DWORD


    .const
      ID_FIRSTDEFCHILD    equ    101                      ; first child window ID


    .data?

    .data

      hinstance               dd        0
      hwndframe               dd        0
      hwndclient              dd        0
      hAccel                  dd        0
      hwnddefchild            dd        0
      hmenu                   dd        0
      hmenu_windows           dd        0
      
      windowname              db   "WindowForge",0
      wclassname              db   "classforge",0
      defchildwin_classname   db   "def_child_class", 0
      menuname                db   "Filemenu",0
      pcommandline            dd        0

      temp                    dd        0
      temp1                   dd        0


      frame_wcl            WNDCLASSEX           { }       ; for the frame window class
      defchild_wcl         WNDCLASSEX           { }       ; for the child window class
      ccs               CLIENTCREATESTRUCT      { }       ; used in the client window creation
      mdics_defchild     MDICREATESTRUCT        { }       ; used in a MDIChild window creation - if using CreateWindowEx then the lparam of CREATESTRUCT contains a pointer to this structure
      cs_defchild          CREATESTRUCT         { }       ; 
      cs_frame             CREATESTRUCT         { }       ; 


  ; ===== Resources =========

      menu_name db      "MDI", 0
      







       
; =============================================================================================


    .code

start:


    invoke GetModuleHandle, NULL
    mov hinstance, eax                  ; instance handle of this application.

    invoke GetCommandLine
    mov pcommandline, eax               ; fetch the command line address


    invoke WinMain, hinstance, NULL, NULL, SW_SHOWDEFAULT

    invoke ExitProcess, eax             ; close this application after the win is destroyed

  
WinMain proc hInstance:DWORD, hPrevInstance:DWORD, lpCmdLine:DWORD, nCmdShow:DWORD

      LOCAL msg                   :MSG

    mov ebx, hInstance             ; handle to the current instance of the application

; -------------------------------------------------------------------------------------------------------
;      fill up the  WNDCLASSEX  structure for the Frame Window
; -------------------------------------------------------------------------------------------------------
;  Typically an MDI Application registers 2 Classes
;
;      Class for the Frame Window
;      Class for the MDI Child Windows
;  The WNDCLASSEX structure is used in both cases
;
;  The Client Window uses a system class "MDICLIENT" specified in the CreateWindowEx function when
;  it is created
;
; -  While creating the window (with CreateWindowEx) value in plParam;
;    For the FrameWindow, a pointer to the CREATESTRUCT structure
;    For the MDI ClientWindow, a pointer to CLIENTCREATESTRUCT
;    For MDI ChildWindows a pointer to the MDICREATESTRUCT structure
;
; -  When using the WM_MDICREATE msg
;    For MDI Child Windows a pointer to the MDICREATESTRUCT structure
; --------------------------------------------------------------------------------------------------------

      mov frame_wcl.cbSize,     sizeof WNDCLASSEX
      mov frame_wcl.style,      CS_HREDRAW or CS_VREDRAW \
                        or      CS_BYTEALIGNWINDOW
      mov frame_wcl.lpfnWndProc,  offset FrameWindowProc
      mov frame_wcl.cbClsExtra,       0                   ; 0 = extra memory not used, 40bytes max
      mov frame_wcl.cbWndExtra,       0
      mov frame_wcl.hInstance,        ebx 
      invoke LoadIcon,NULL, IDI_ASTERISK
      mov frame_wcl.hIcon,            eax                 ; ALT+TAB icon etc
      invoke LoadCursor, NULL, IDC_ARROW                  ; predefined cursor (could use LoadImage)
      mov frame_wcl.hCursor,          eax
      mov frame_wcl.hbrBackground,    COLOR_BTNFACE+1
      mov frame_wcl.lpszMenuName,     offset menu_name    ; automatically assigns the menu to the window when its created
      mov frame_wcl.lpszClassName,    offset wclassname
      mov frame_wcl.hIconSm,          NULL                ; window's title bar icon etc


   invoke RegisterClassEx, addr frame_wcl                 ; register the frame class


; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
;   Fill up the WNDCLASSEX structure for the default child window
;   A seperate Class should be registered for each 'type' of child window.
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

      mov defchild_wcl.cbSize,              sizeof WNDCLASSEX
      mov defchild_wcl.style,               CS_HREDRAW or CS_VREDRAW \
                                            or CS_BYTEALIGNWINDOW
      mov defchild_wcl.lpfnWndProc,         offset DefChildWindowProc
      mov defchild_wcl.cbClsExtra,          0                   ; 0 = extra memory not used, 40bytes max
      mov defchild_wcl.cbWndExtra,          32
      mov defchild_wcl.hInstance,           ebx 
      invoke LoadIcon, NULL, IDI_ASTERISK
      mov defchild_wcl.hIcon,               eax                 ; ALT+TAB icon etc
      invoke LoadCursor, NULL, IDC_ARROW                        ; predefined cursor (could use LoadImage)
      mov defchild_wcl.hCursor,             eax
      mov defchild_wcl.hbrBackground,       COLOR_BTNFACE+1
      mov defchild_wcl.lpszMenuName,        0                   ; NULL since a child window can't have its own menu
      mov defchild_wcl.lpszClassName,       offset defchildwin_classname
      mov defchild_wcl.hIconSm,             NULL                ; window's title bar icon etc


   invoke RegisterClassEx, addr defchild_wcl                    ; register the default child window class
    

  ; -------------------------
  ;             Create the Frame Window
  ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

    invoke CreateWindowEx,
           WS_EX_OVERLAPPEDWINDOW,
           addr wclassname, 
           addr windowname,        
           WS_OVERLAPPEDWINDOW\
                 or WS_HSCROLL\   
                 or WS_VSCROLL,
           CW_USEDEFAULT, 
           CW_USEDEFAULT,
           CW_USEDEFAULT,
           CW_USEDEFAULT, 
           NULL,
           NULL,
           hInstance,                      
           NULL                             

    mov hwndframe, eax                            ; returns the handle to the new window created.

    invoke ShowWindow, hwndframe, SW_SHOWNORMAL
    invoke UpdateWindow, hwndframe                ; Updates the client area by sending a WM_PAINT

; =================================================================================================================================

    MessageLoop:                              ; checks return values from the GetMessage Function
      invoke GetMessage, addr msg, NULL, 0, 0 ; retrieves a msg & removes it from the que & places it in a MSG structure
                                          
      .if eax == SDWORD ptr -1                ; === check for an error ===
        push eax
        fn MessageBox, 0, "GetMessage Error", "Error", MB_OK
        pop eax
        invoke DestroyWindow, hwndframe
      .endif                              
                                          
      cmp eax, 0                               ; 0 = WM_QUIT message retrieved by GetMessage -> exit the Loop
        jz ExitMsgLoop                    

        invoke TranslateMDISysAccel, hwndclient, addr msg
        cmp eax, 0                        ; returns False if not an MDIAcclmsg, else sends them to the active MDI child window
        jne MessageLoop                   ; loop if not false
        invoke TranslateAccelerator, hwndframe, hAccel, addr msg
        cmp eax, 0
        jne MessageLoop                   ; loop back if true (msg was processed)
   
        invoke TranslateMessage, addr msg ; translates virtual-key messages into character messages. 
        invoke DispatchMessage,  addr msg ; else Dispatch the Message to the WndProc for the window
        jmp MessageLoop
    ExitMsgLoop:
      mov eax, msg.wParam                 ; return the value passed in the WM_QUIT message's wParam parameter.
      ret                                 

  WinMain endp


; ======================================================================================================================================================


    FrameWindowProc proc hWndframe:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD


      .if uMsg == WM_CREATE

        mov eax, hWndframe
        mov hwndframe, eax

        call create_MDIClient_window           ; creates the MDI client & 1st child, windows


        return 0

      .elseif uMsg == WM_PARENTNOTIFY


  ; -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  
  ;  Activates the MDI child window that the user chooses. This message is sent when the user chooses an MDI child window
  ;  from the window menu of the MDI frame window. The window identifier accompanying this message identifies the
  ;  MDI child window to be activated.
  ;  must be passed to DefFrameProc even if processed
  ; -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  
  
      .elseif uMsg == WM_COMMAND

  

  ; ----------------------------------------------------------
  ;   Paint the window's client area.
  ; ----------------------------------------------------------

      .elseif uMsg == WM_PAINT
      
        ; xor eax, eax
        ; ret

      .elseif uMsg == WM_ERASEBKGND

      
  ; -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  
  ;   set the size & position of the window.
  ; * must be passed to DefFrameProc even if processed
  ;   Resizes the MDI client window to fit in the new frame window's client area. 
  ; -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  

      .elseif uMsg == WM_SIZE

       ;  jmp default_processing          
       ;  xor eax, eax
       ;  ret

  ; -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  
  ;   Opens the window menu of the active MDI child window when the user presses ALT+  
  ; * must be passed to DefFrameProc even if processed
  ; -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  
  
      .elseif uMsg == WM_MENUCHAR

  ;   Passes the keyboard focus to the MDI client window, which in turn passes it to the active MDI child window
  ; * Must be passed to DefFrameProc even if processed

      .elseif uMsg == WM_SETFOCUS

     
      .elseif uMsg == WM_DESTROY
         
          invoke PostQuitMessage, NULL                ; if the main window is being destroyed
          return 0                                    ; 0 = proc processed the msg

      .elseif uMsg == WM_CLOSE
          jmp @F
          fn MessageBox, NULL, "do you wanna quit", "Exit", MB_YESNO
          cmp eax, IDYES
          jne @F
           
      @@:
          invoke DestroyWindow, hWndframe                ; if IDYES -> quit
          return 0

      .endif
    
   comment 
   -------------------------------------------------------------------------------------------------------------
      The Frame  Window Procedure must pass the following messages to DefFrameProc even if it does handle them
      or forego some functionality.
          WM_command, WM_MENUCHAR, WM_SETFOCUS, WM_SIZE
      The window procedure returns the value returned by DefFrameProc as its own message result.
   ------------------------------------------------------------------------------------------------------------- 

      default_processing:
      invoke DefFrameProc, hWndframe, hwndclient, uMsg, wParam, lParam   ; default processing
        
      ret

    FrameWindowProc endp



; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
;             Default MDI Child Window Procedure
; -------------------------------------------------------------------------------------------------------------------------
;  The following window management mesages must be sent to DefMDIChildProc even if the application handles the message,
;  in order for MDI to function correctly
;  WM_CHILDACTIVATE, WM_GETMINMAXINFO, WM_MENUCHAR, WM_MOVE, WM_SETFOCUS, WM_SIZE, WM_SYSCOMMAND
; -------------------------------------------------------------------------------------------------------------------------



DefChildWindowProc proc HWnddefchild:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD








      default_processing:
      invoke DefMDIChildProc, hwnddefchild, uMsg, wParam, lParam       ; default processing
       
      ret

DefChildWindowProc endp



; ----------------------------------------------------------------------------------------------------------------------
;    Create the client window and First Child Window
; --------------------------------------------------------------------------------
;    An MDI client window is a special type of child window belonging to the preregistered window class MDICLIENT. 
;    The last parameter (lpParam) should point to the CLIENTCREATESTRUCT
; ----------------------------------------------------------------------------------------------------------------------

  create_MDIClient_window:

    push ebx
    push esi

    invoke GetMenu, hwndframe
    mov hmenu, eax
    invoke GetSubMenu, hmenu, 1
    mov hmenu_windows, eax          ; handle to the 'Window' Menu

    mov esi, offset ccs   
    mov [esi.CLIENTCREATESTRUCT.hWindowMenu], eax
    mov [esi.CLIENTCREATESTRUCT.idFirstChild], ID_FIRSTDEFCHILD     ; fill in the Structure
     
    invoke CreateWindowEx, NULL, chr$("MDICLIENT",0), NULL,        
           WS_CHILD or WS_CLIPCHILDREN or MDIS_ALLCHILDSTYLES or WS_HSCROLL or WS_VSCROLL,
           CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
           hwndframe, hmenu_windows,
           hinstance,                      
           addr ccs                              

    mov hwndclient, eax
    cmp eax, 0
    jne @F
    invoke GetLastError
    fn MessageBox,0,str$(eax),"Client Window Creation Failed",MB_OK
    pop esi
    pop ebx
    ret

  @@:
    invoke ShowWindow, hwndclient, SW_SHOWNORMAL
    invoke UpdateWindow, hwndclient


  ; ---- create the first child window -------------------------------------
  
comment 
 ;  fill in the MDICREATESTRUCT structure
    mov esi, offset mdics_defchild
    mov [esi.MDICREATESTRUCT.szClass], offset defchildwin_classname
    mov [esi.MDICREATESTRUCT.szTitle], chr$("child window", 0)
    mov ebx, hinstance
    mov [esi.MDICREATESTRUCT.hOwner], ebx
    mov [esi.MDICREATESTRUCT.x], CW_USEDEFAULT
    mov [esi.MDICREATESTRUCT.y], CW_USEDEFAULT
    mov (MDICREATESTRUCT ptr [esi]).lx, CW_USEDEFAULT
    mov [esi.MDICREATESTRUCT.ly], CW_USEDEFAULT
    mov [esi.MDICREATESTRUCT.style], WS_MAXIMIZE 
    mov [esi.MDICREATESTRUCT.lParam], 0



fn MessageBox,0,str$(hwndclient),"hwndclient",MB_OK


    invoke CreateWindowEx, WS_EX_MDICHILD, addr defchildwin_classname,
           chr$("mdi child window",0),        
           WS_CHILD or MDIS_ALLCHILDSTYLES or WS_HSCROLL or WS_VSCROLL,
           50, CW_USEDEFAULT, 200, 200, 
           hwndclient, ID_FIRSTDEFCHILD, hinstance,                      
           addr mdics_defchild       

   mov hwnddefchild, eax
   cmp eax, 0
   jne @F
   invoke GetLastError
   fn MessageBox,0,str$(eax),"GetLastError (child win)",MB_OK
   ; fn MessageBox,0,ustr$(hwnddefchild),"Child win handle",MB_OK
   pop esi
   pop ebx
   ret

 @@:  

   invoke ShowWindow, hwnddefchild, SW_SHOWNORMAL
   

   pop esi
   pop ebx

   ret


end start
































































comment 
-----------------------------------------------------------------------------------------
                            Notes

    Extra Class & WindowMemory
    
  * If an application requires more than 40 bytes, it should allocate its own memory
    and store a pointer to the memory in the extra class memory.
    SetClassWord and SetClassLong, GetClassLong 
    SetWindowLong GetWindowLong
    
  * 

------------------------------------------------------------------------------------------ 








